



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>基于AD5663的UV灯电压控制</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">基于AD5663的UV灯电压控制</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 22:08:47 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在开发臭氧发生器的时，我们使用UV灯来实现臭氧的产生。而UV灯的强度决定了臭氧产生的浓度，UV灯的光强则与其控制电压密切相关。所以我们要控制产生的臭氧的浓度就需要调节其控制电压。我们选择了AD5663这一模拟量输出模块来实现这一点。</p>
<p><strong>1</strong><strong>、</strong><strong>AD5663</strong><strong>简介</strong></p>
<p>AD5663属于nanoDAC系列，是低功耗、双通道、16位缓冲电压输出数模转换器(DAC)，采用2.7V至5.5V单电源供电。AD5663采用多功能三线式串行接口，能够以最高50 MHz的时钟速率工作，并与标准SPI、QSPI、MICROWIRE、DSP接口标准兼容。它内置片内精密输出放大器，能够实现轨到轨输出摆幅。其功能框图如下所示：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/564295/201711/564295-20171112150303059-1098185357.png" /></p>
<p><strong>2</strong><strong>、硬件设计</strong></p>
<p>我们用来产生臭氧的UV灯，其控制电压约需要在AC300V到AC1500V的范围，工作频率约为10kHz到20kHz的范围内，当然选用的灯不一样可能会有些许差异。为了达到这个目的，我们使用两个PWM控制电路产生低压交流电源，然后通过高频变压器产生我们需要的交流电源。基于此，我们先要有一个连续可调的低压直流电源才有可能通过PWM控制电路达到我们想要的结果。如下图即是我们电压控制电路：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/564295/201711/564295-20171112150312841-1189984853.png" /></p>
<p>上图中我们采用LM2596S-ADJ作为电源模块，以AD5663作为电源调节输出。LM2596S的反馈电压要求在1.23V，二极管的1N4001的管压降设定为0.5V，根据R27、R28、R29几个电阻电路就可以实现LM2596S输出电压的调节。由于二极管的存在，AD5663需要输出大于1.73V（1.23V+0.5V）以上的电压才能起到调节效果。我们设返回电压为Vf=1.23V，LM2596S的输出电压为Vo，二极管的管压降为Vd，AD5633的输出电压为Vs于是我们可以得到一个等式：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/564295/201711/564295-20171112150333294-1989043908.png" /></p>
<p>在上述等式中Vf=1.23V是确定的，二极管的管压降Vd=0.5V也是确定的，所以等式有2中情况：第一种是AD5663的输出电压小于等于1.73时，AD5663的输出对电压输出没有影响；第二种是当AD5663的输出电压大于1.73时，可以通过AD5663的输出调节LM2596S的输出，而且为线性关系。</p>
<p><strong>3</strong><strong>、软件设计</strong></p>
<p>经过上述的分析和设计，相关软件的编写就变得相对容易了。AD5663有一个输入移位寄存器，对AD5663操作都是通过输入移位寄存器来实现的。</p>
<p><strong>（</strong><strong>1</strong><strong>）输入移位寄存器</strong></p>
<p>输入移位寄存器为24位宽。前2位是无关位，后续三位是命令位C2至C0，然后是3位DAC地址A2至A0，其结构如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/564295/201711/564295-20171112150348044-774894342.png" /></p>
<p><strong>（</strong><strong>2</strong><strong>）软件复位</strong></p>
<p>软件复位也是通过操作输入移位寄存器来实现的。命令位的定义没有变化，数据段的最后一位作为软件复位的模式设定，其它位无效。最后一位为0时，会清除DAC寄存器和输入寄存器，而最后一位为1时清除掉全部寄存器。最后一位为1时，实际就是上电复位模式。输入移位寄存器的数据格式如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/564295/201711/564295-20171112150358138-1848568951.png" /></p>
<p>其软件实现如下：</p>
<div>
<pre class="prettyprint linenums"> void Ad5663SoftwareReset(AD5663ResetType resetMode,void (*WriteByteToAD5663)(uint8_t))<br />
 {<br />
   uint32_t inputShiftData=;

   if(resetMode==ResetSoftware)<br />
   {<br />
     inputShiftData=RESET|Register_Reset_Software;<br />
   }

   if(resetMode==ResetPoweron)<br />
   {<br />
     inputShiftData=RESET|Register_Reset_Poweron;<br />
   }<br />
   uint8_t txData[];<br />
   txData[]=inputShiftData&gt;&gt;;<br />
   txData[]=inputShiftData&gt;&gt;;<br />
   txData[]=inputShiftData;

   WriteByteToAD5663(txData[]);<br />
   WriteByteToAD5663(txData[]);<br />
   WriteByteToAD5663(txData[]);<br />
 }</pre>
</div>
<p><strong>（</strong><strong>3</strong><strong>）上电复位</strong></p>
<p>上电复位也是通过操作输入移位寄存器来实现的。命令位的定义没有变化，数据段的DB5和DB4定义掉电的模式，而DB1和DB0定义操作的通道。输入移位寄存器的数据格式如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/564295/201711/564295-20171112150410716-2124978194.png" /></p>
<p>其软件实现如下：</p>
<div>
<pre class="prettyprint linenums">/*设置AD5663上电/掉电工作模式*/<br />
void Ad5663PowerUpDownMode(DACHANNEL channel,AD5663PowerdownType powerdownType,void (*WriteByteToAD5663)(uint8_t))<br />
{<br />
  uint32_t inputShiftData=;

  if(channel==DAChannelA)<br />
  {<br />
    inputShiftData=DAC_A;<br />
  }

  if(channel==DAChannelB)<br />
  {<br />
    inputShiftData=DAC_B;<br />
  }

  if(channel==ChannelAll)<br />
  {<br />
    inputShiftData=DAC_A|DAC_B;<br />
  }

  switch(powerdownType)<br />
  {<br />
  case NormalOperation:<br />
    {<br />
      inputShiftData=inputShiftData|Normal_Operation|Power_Down;<br />
      break;<br />
    }<br />
  case R1K2GND:

    {<br />
      inputShiftData=inputShiftData|_1K_GND|Power_Down;<br />
      break;<br />
    }<br />
  case R100K2GND:<br />
    {<br />
      inputShiftData=inputShiftData|_100K_GND|Power_Down;<br />
      break;<br />
    }<br />
  case ThreeState:<br />
    {<br />
      inputShiftData=inputShiftData|Three_State|Power_Down;<br />
      break;<br />
    }<br />
  }</pre>
</div>
<p><strong>（</strong><strong>4</strong><strong>）输出操作</strong></p>
<p>对各输出通道值的操作也是同过输入移位寄存器来完成。其数据格式如前面输入移位寄存器的介绍。后16位是数据（0-65535），然后是3位地址和3位命令。通讯的时序图如下所示：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/564295/201711/564295-20171112150429044-80401640.png" /></p>
<div>
<pre class="prettyprint linenums"> 设置DA通道的值具体代码如下：<br />
 void SetAD5663ChannelValue(DACHANNEL channel,uint16_t data,void (*WriteByteToAD5663)(uint8_t))<br />
 {<br />
   uint32_t inputShiftData=;<br />
   if(channel==DAChannelA)<br />
   {<br />
     inputShiftData=WriteTo_Update_DAC_Channel|DAC_Channel_A|data;<br />
   }

   if(channel==DAChannelB)<br />
   {<br />
     inputShiftData=WriteTo_Update_DAC_Channel|DAC_Channel_B|data;<br />
   }<br />
   uint8_t txData[];<br />
   txData[]=inputShiftData&gt;&gt;;<br />
   txData[]=inputShiftData&gt;&gt;;<br />
   txData[]=inputShiftData;

   WriteByteToAD5663(txData[]);<br />
   WriteByteToAD5663(txData[]);<br />
   WriteByteToAD5663(txData[]);<br />
 }</pre>
</div>
<p>欢迎关注：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/564295/201711/564295-20171112150839841-1305998581.jpg" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/495d47zq.html">&lbrack;刘阳Java&rsqb;&lowbar;斗胆介绍一下Eclipse快捷键大全&lbrack;超详细&rsqb;&lowbar;第6讲</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxro1vq.html">3&period;聚类&amp;ndash&semi;K-means的Java实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyjkxxq.html">极值问题（acms）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdo6mk8.html">ASP&period;NET MVC 4 WebAPI&period; Support Areas in HttpControllerSelector</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd0p7m8.html">WCF学习笔记&lpar;2&rpar;&mdash;&mdash;使用IIS承载WCF服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vy3z38.html">UOJ &num;148&period; 【NOIP2015】跳石头 二分</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xlyme8.html">JavaScript获取网页属性包括宽、高等</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdy3ol8.html">nim</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1wenv9.html">http&colon;&sol;&sol;msh&period;baidu&period;com&sol;UTWpR6wY4722</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm22le9.html">SSAS维度设计中CustomRollupColumn的用法-自定义聚合方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde6lej9.html">解决Flex4 发布后访问 初始化极其缓慢的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjkwrk8.html">Uva 167 The Sultan&amp;&num;39&semi;s Successors&lpar;dfs&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv12zvxq.html">android 使用asm&period;jar将android手机屏幕投射到电脑</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpodg59.html">HDOJ-1051 Wooden sticks（贪心）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj5w3lq.html">java学习笔记 --- String类</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1rr0zq.html">Linux文件属性及如何修改文件属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j11lwe9.html">微信小程序我的界面</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4wklk9.html">transition属性值</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnjekxq.html">Android studio安装配置常见问题及其解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp4wp79.html">DATEDIFF 和 DATEADD</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pwkydk8.html">为数据库重新生成log文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdorde9.html">GCC编译器原理（二）------编译原理一：ELF文件（3）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9607kgn9.html">【LeetCode】108&period; Convert Sorted Array to Binary Search Tree</a>
			</li>
						<li><a href="https://www.batexi.com/a/9607knv9.html">MySQL Errno &colon; 1062 错误修复</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e45lye9.html">自己对Java的一点看法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2l5lpq.html">linux  atoi</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1nok09.html">TCC</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2z6dj9.html">mybatis resultType resultMap 区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwk1e78.html">shell脚本 统计一段程序运行时间【转】</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r50zwdq.html">python3&plus;selenium框架设计06-编写POM测试用例</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
